CREATE TABLE FK_RAPORT (
    ID                  INTEGER NOT NULL,
	ID_DOKUMENTU        INTEGER,
	ID_PARENT           INTEGER,
	ID_CHILD            INTEGER,
    DZIAL               CHAR(3),
    ROZDZIAL            CHAR(5),
    PAR                 CHAR(3),
    PAR4                CHAR(1),
	ID_ZADANIA          INTEGER,
    BUDZET              DOUBLE PRECISION,
    ZAANGAZOWANIE       DOUBLE PRECISION,
    REALIZACJA          DOUBLE PRECISION,
    JEST_ZAANGAZOWANIE  CHAR(1)
);

/*--------------------------------------------------------------- */

DROP PROCEDURE WYDRUK_RB28;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE PROCEDURE WYDRUK_RB28 (
    id integer,
    rokb varchar(4),
    dataod date,
    datado date,
    id_jb integer,
    typ_jb varchar(250))
returns (
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    budzet double precision,
    zaangazowanie double precision,
    realizacja double precision,
    jest_zaangazowanie char(1))
as
declare variable poziom varchar(15);
begin
   /* Plan budzetowy */
   for select jp.DZIAL,jp.ROZDZIAL,jp.PAR,jp.PAR4,sum(jp.WARTOSC) as BUDZET
   from
   PB_UCHWALY u
   join PB_BUDZET_J bj on (bj.ID_UCHWALY = u.ID_UCHWALY and bj.STATUS in (0, 9))
   join PB_BUDZET_J_POZ jp on (bj.IDSPRAW = jp.IDSPRAW)
   where
   u.DATA_UOD<=:DATADO and u.ROKB=:ROKB and
   (bj.ID_JB = :ID_JB or bj.ID_JB in (select ID_JB
   from GET_JB_FROM_TYP (:TYP_JB) ))
   and  jp.WARTOSC<>0
   and jp.PRZEPLYW='W'
   group by jp.DZIAL,jp.ROZDZIAL,jp.PAR,jp.PAR4
   order by jp.DZIAL,jp.ROZDZIAL,jp.PAR,jp.PAR4
   into
      :DZIAL, :ROZDZIAL,:PAR, :PAR4, :BUDZET
   do
   begin
         insert into FK_RAPORT(ID, DZIAL, ROZDZIAL,  PAR, PAR4,  BUDZET, JEST_ZAANGAZOWANIE ) values
         (:ID,:DZIAL, :ROZDZIAL,  :PAR, :PAR4,  :BUDZET, 'N' );
   end

   /*Zaangazowanie */
   for select dekr.DZIAL,dekr.ROZDZIAL,dekr.PAR,dekr.PAR4,sum(dekr.KWOTA) as ZAANGAZOWANIE
   from FK_DEKRETACJA dekr
   join FK_TERMINY ter on (dekr.ID_TERMINY = ter.ID)
   join FK_DOKUMENTY dok on (dok.ID=ter.ID_DOKUMENTY)
   join FK_S_DOKUMENTY sdok on (dok.ID_S_DOKUMENTY = sdok.ID and sdok.ZAANGAZOWANIE like 'Ma')
   join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and s.CZY_ZATWIERDZONY='T'
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
   join FK_S_STATUSY sta
   on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N' and sta.CZY_ZATWIERDZONY='T')
   where extract(year from dok.DATA_DOK) = cast( :ROKB as Integer)  and
   extract(year from ter.TERMIN) = cast (:ROKB as Integer) and
   (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB) )) and
   dok.DATA_DOK >= :DATAOD and
   dok.DATA_DOK <= :DATADO
   group by dekr.DZIAL,dekr.ROZDZIAL,dekr.PAR,dekr.PAR4
   into :DZIAL,:ROZDZIAL,:PAR,:PAR4,:ZAANGAZOWANIE
   do
   begin
        update FK_RAPORT set ID=:ID, ZAANGAZOWANIE=:ZAANGAZOWANIE,  JEST_ZAANGAZOWANIE= 'T'
        where  DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL and  PAR=:PAR and PAR4=:PAR4;
   end

   /*Realizacja*/
   for select dekr.DZIAL,dekr.ROZDZIAL,dekr.PAR,dekr.PAR4,sum(dekr.KWOTA) as REALIZACJA,
   sp.KOD as POZIOM
   from FK_DEKRETACJA dekr
   join FK_TERMINY ter on dekr.ID_TERMINY = ter.ID
   join FK_DOKUMENTY dok on ter.ID_DOKUMENTY = dok.ID
   join FK_S_DOKUMENTY sdok on dok.ID_S_DOKUMENTY = sdok.ID
   join (
        select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
        from FK_DOKUMENTY d
        join FK_S_STATUSY s on d.STATUS = s.ID
        where s.CZY_USUNIETY = 'N'
        and s.CZY_ZATWIERDZONY='T'
        and d.DATA_DOK >= :DATAOD
        and d.DATA_DOK <= :DATADO
        group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
   join FK_S_POZIOMY sp on (sdok.ID_S_POZIOMY=sp.ID and sp.KOD='REALIZACJA')
   join FK_S_STATUSY sta
   on  (sta.ID=dok.STATUS  and sta.CZY_USUNIETY='N' and sta.CZY_ZATWIERDZONY='T')
   where extract(year from dok.DATA_DOK) = cast (:ROKB as Integer)  and
   extract(year from ter.TERMIN) = cast (:ROKB as Integer) and
   (dok.ID_JB = :ID_JB or dok.ID_JB in (select ID_JB from GET_JB_FROM_TYP (:TYP_JB) )) and
   dok.DATA_DOK >= :DATAOD and
   dok.DATA_DOK <= :DATADO
   group by dekr.DZIAL,dekr.ROZDZIAL,dekr.PAR,dekr.PAR4,sp.KOD
   into :DZIAL,:ROZDZIAL,:PAR,:PAR4,:REALIZACJA,:POZIOM
   do
   begin
        update FK_RAPORT set ID=:ID, REALIZACJA=:REALIZACJA,  JEST_ZAANGAZOWANIE= 'T'
        where  DZIAL=:DZIAL and  ROZDZIAL=:ROZDZIAL and  PAR=:PAR and PAR4=:PAR4;
   end
   
   /* Wyswietlenie wynikow */
   for select r.DZIAL, r.ROZDZIAL, r.PAR, r.PAR4, r.BUDZET, r.ZAANGAZOWANIE, r.REALIZACJA,
   r.JEST_ZAANGAZOWANIE from FK_RAPORT r
   into :DZIAL, :ROZDZIAL, :PAR, :PAR4, :BUDZET, :ZAANGAZOWANIE, :REALIZACJA, :JEST_ZAANGAZOWANIE
   do
   begin
      suspend;
   end


end^

SET TERM ; ^

GRANT SELECT ON PB_UCHWALY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON PB_BUDZET_J TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON PB_BUDZET_J_POZ TO PROCEDURE WYDRUK_RB28;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE WYDRUK_RB28;

GRANT SELECT,INSERT,UPDATE ON FK_RAPORT TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_DEKRETACJA TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_TERMINY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_S_DOKUMENTY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE WYDRUK_RB28;

GRANT SELECT ON FK_S_POZIOMY TO PROCEDURE WYDRUK_RB28;

GRANT EXECUTE ON PROCEDURE WYDRUK_RB28 TO SYSDBA;

/*--------------------------------------------------------------- */
