SET TERM ^ ;

CREATE OR ALTER PROCEDURE GET_JB_FROM_LIST (
    jednostki varchar(3000))
returns (
    id_jb integer,
    kod_jb varchar(15))
as
declare variable procj varchar(3000);
begin
  /* Procedure Text */

  if (JEDNOSTKI = '') then
    exception EX_PUSTY_PARAMETR;

  PROCJ= 'select j.ID_JB, j.KOD_JB from PB_S_JB j  where j.ID_JB in ('||:JEDNOSTKI||') ' ;

  for EXECUTE STATEMENT :PROCJ
  into :ID_JB, :KOD_JB
  do
  suspend;
end^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_LIST TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_LIST TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT_JB;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_LIST TO PROCEDURE GET_ZAANG_EKSPORT_GR_ZAD;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_LIST TO PROCEDURE GET_ZAANG_EKSPORT_RODZ_ZAD;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_LIST TO SYSDBA;


/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE OR ALTER PROCEDURE GET_JB_FROM_TYP (
    typy_jb varchar(3000))
returns (
    id_jb integer)
as
declare variable stmt varchar(3000);
begin
  /* Procedure Text */

   STMT=
   'select distinct jb.ID_JB
    from PB_S_JB  jb where jb.TYP_JB in ('||:TYPY_JB||')';

   if (TYPY_JB<>'') then
   begin
      for EXECUTE STATEMENT  :STMT
      into :ID_JB
      do
      suspend;
   end
   else
   begin
     ID_JB=0;
     suspend;
   end

end^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_PLAN_ZAANG_ZOBW_REALIZ;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANGAZOWANIE;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANGAZOWANIE_DRP;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANGAZOWANIE_DRP_GP;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_BEZ_DOK;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_KONTO;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_KONTO_ROZNICA_OKRES;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_MIESIAC;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_ROK_NAST;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_SAMODZ_REALIZ;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_SAMODZ_REALIZ_DRP_GP;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_ZOBW_REALIZ;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE GET_ZAANG_ZOBW_REALIZ_DRP_GP;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO PROCEDURE WYDRUK_RB28;
GRANT EXECUTE ON PROCEDURE GET_JB_FROM_TYP TO SYSDBA;

/*--------------------------------------------------------------- */

SET TERM ^ ;

CREATE OR ALTER PROCEDURE GET_ZAANGAZOWANIE_EKSPORT (
    id integer,
    dataod1 date,
    datado1 date,
    dataod2 date,
    datado2 date,
    jednostki varchar(3000))
returns (
    id_jb integer,
    wn double precision,
    ma double precision,
    kod_full varchar(250),
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    kod_z varchar(15))
as
begin
  /* Okres pierwszy */
  for  select '0' as ID_JB, 0 as WN, sum (ks.KWOTA) as MA ,
   0 as KOD_FULL, plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, z.KOD_Z
  from  FK_KSIEGOWANIA ks
  join FK_S_PLAN_KONT plk on (plk.ID = ks.ID_KONTA_MA)
  join FK_DOKUMENTY dok  on (ks.ID_DOKUMENTY = dok.ID )
  join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY= 'T')
      and (d.data_dok between :DATAOD1 and :DATADO1)
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
  left join PB_ZADANIA z on (z.ID_ZADANIA = plk.ID_ZADANIA)
  where dok.ID_JB in ( select ID_JB from GET_JB_FROM_LIST (:JEDNOSTKI) )
  and (dok.data_dok between  :DATAOD1 and :DATADO1 )
  group by
  plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, z.KOD_Z
  into :ID_JB, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z
  do
  begin
    insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, ZAANGAZOWANIE, REALIZACJA,
     NAZWA, DZIAL, ROZDZIAL, PAR, PAR4, KOD)
    values
    (:ID, :ID_JB, 1, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :KOD_Z) ;
  end


  /* Okres drugi */
  for  select '0' as ID_JB, 0 as WN, -sum (ks.KWOTA) as MA ,
   0 as KOD_FULL, plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, z.KOD_Z
  from  FK_KSIEGOWANIA ks
  join FK_S_PLAN_KONT plk on (plk.ID = ks.ID_KONTA_MA)
  join FK_DOKUMENTY dok  on (ks.ID_DOKUMENTY = dok.ID )
  join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY= 'T')
      and (d.data_dok between :DATAOD2 and :DATADO2)
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
  left join PB_ZADANIA z on (z.ID_ZADANIA = plk.ID_ZADANIA)
  where dok.ID_JB in ( select ID_JB from GET_JB_FROM_LIST (:JEDNOSTKI) )
  and (dok.data_dok between  :DATAOD2 and :DATADO2 )
  group by
  plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, z.KOD_Z
  into :ID_JB, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z
  do
  begin
   insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, ZAANGAZOWANIE, REALIZACJA,
     NAZWA, DZIAL, ROZDZIAL, PAR, PAR4, KOD)
    values
    (:ID, :ID_JB, 2, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :KOD_Z) ;
  end

   /* Sumowanie okresw */
   for select rp.ID_DOKUMENTU, sum (rp.ZAANGAZOWANIE), sum (rp.REALIZACJA), rp.DZIAL, rp.ROZDZIAL,
   rp.PAR, rp.PAR4, rp.KOD, rp.NAZWA
   from  FK_RAPORT rp where rp.ID =:ID
   group by  rp.ID_DOKUMENTU, rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.KOD, rp.NAZWA
   into :ID_JB, :WN, :MA, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z, :KOD_FULL
   do
   begin
       if (:WN<>0 or :MA<>0) then suspend;
   end

    /*Usuwanie rekordw*/

   execute procedure CLEAN_RAPORT :ID;


end^

SET TERM ; ^

GRANT SELECT ON FK_KSIEGOWANIA TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;

GRANT SELECT ON FK_S_PLAN_KONT TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;

GRANT SELECT ON PB_ZADANIA TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_LIST TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;

GRANT SELECT,INSERT ON FK_RAPORT TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;

GRANT EXECUTE ON PROCEDURE CLEAN_RAPORT TO PROCEDURE GET_ZAANGAZOWANIE_EKSPORT;

GRANT EXECUTE ON PROCEDURE GET_ZAANGAZOWANIE_EKSPORT TO SYSDBA;

/*--------------------------------------------------------------- */


SET TERM ^ ;

CREATE OR ALTER PROCEDURE GET_ZAANG_EKSPORT_GR_ZAD (
    id integer,
    dataod1 date,
    datado1 date,
    dataod2 date,
    datado2 date,
    jednostki varchar(3000))
returns (
    id_jb integer,
    wn double precision,
    ma double precision,
    kod_full varchar(250),
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    kod_z varchar(15))
as
begin
  /* Okres pierwszy */
  for  select '0' as ID_JB, 0 as WN, sum (ks.KWOTA) as MA ,
   ' ' as KOD_FULL, plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, 'INNE' as KOD_Z
  from  FK_KSIEGOWANIA ks
  join FK_S_PLAN_KONT plk on (plk.ID = ks.ID_KONTA_MA)
  join FK_DOKUMENTY dok  on (ks.ID_DOKUMENTY = dok.ID )
  join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY= 'T')
      and (d.data_dok between :DATAOD1 and :DATADO1)
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
  where dok.ID_JB in ( select ID_JB from GET_JB_FROM_LIST (:JEDNOSTKI) )
  and (dok.data_dok between  :DATAOD1 and :DATADO1 )
  group by
  plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4
  into :ID_JB, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z
  do
  begin
    insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, ZAANGAZOWANIE, REALIZACJA,
     NAZWA, DZIAL, ROZDZIAL, PAR, PAR4, KOD)
    values
    (:ID, :ID_JB, 1, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :KOD_Z) ;
  end


  /* Okres drugi */

  for  select '0' as ID_JB, 0 as WN, -sum (ks.KWOTA) as MA ,
   ' ' as KOD_FULL, plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, 'INNE' as KOD_Z
  from  FK_KSIEGOWANIA ks
  join FK_S_PLAN_KONT plk on (plk.ID = ks.ID_KONTA_MA)
  join FK_DOKUMENTY dok  on (ks.ID_DOKUMENTY = dok.ID )
  join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY= 'T')
      and (d.data_dok between :DATAOD2 and :DATADO2)
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
  where dok.ID_JB in ( select ID_JB from GET_JB_FROM_LIST (:JEDNOSTKI) )
  and (dok.data_dok between  :DATAOD2 and :DATADO2 )
  group by
  plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4
  into :ID_JB, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z
  do
  begin
   insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, ZAANGAZOWANIE, REALIZACJA,
     NAZWA, DZIAL, ROZDZIAL, PAR, PAR4, KOD)
    values
    (:ID, :ID_JB, 2, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :KOD_Z) ;
  end

   /* Sumowanie okresw */

   for select rp.ID_DOKUMENTU, sum (rp.ZAANGAZOWANIE), sum (rp.REALIZACJA), rp.DZIAL, rp.ROZDZIAL,
   rp.PAR, rp.PAR4, rp.KOD, rp.NAZWA
   from  FK_RAPORT rp where rp.ID =:ID
   group by  rp.ID_DOKUMENTU, rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.KOD, rp.NAZWA
   into :ID_JB, :WN, :MA, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z, :KOD_FULL
   do
   begin
       if (:WN<>0 or :MA<>0) then suspend;
   end

    /*Usuwanie rekordw*/

   execute procedure CLEAN_RAPORT :ID;


end^

SET TERM ; ^

GRANT SELECT ON FK_KSIEGOWANIA TO PROCEDURE GET_ZAANG_EKSPORT_GR_ZAD;

GRANT SELECT ON FK_S_PLAN_KONT TO PROCEDURE GET_ZAANG_EKSPORT_GR_ZAD;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANG_EKSPORT_GR_ZAD;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANG_EKSPORT_GR_ZAD;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_LIST TO PROCEDURE GET_ZAANG_EKSPORT_GR_ZAD;

GRANT SELECT,INSERT ON FK_RAPORT TO PROCEDURE GET_ZAANG_EKSPORT_GR_ZAD;

GRANT EXECUTE ON PROCEDURE CLEAN_RAPORT TO PROCEDURE GET_ZAANG_EKSPORT_GR_ZAD;

GRANT EXECUTE ON PROCEDURE GET_ZAANG_EKSPORT_GR_ZAD TO SYSDBA;


/*--------------------------------------------------------------- */


SET TERM ^ ;

CREATE OR ALTER PROCEDURE GET_ZAANG_EKSPORT_RODZ_ZAD (
    id integer,
    dataod1 date,
    datado1 date,
    dataod2 date,
    datado2 date,
    jednostki varchar(3000))
returns (
    id_jb integer,
    wn double precision,
    ma double precision,
    kod_full varchar(250),
    dzial varchar(3),
    rozdzial varchar(5),
    par varchar(3),
    par4 varchar(1),
    kod_z varchar(15))
as
begin
  /* Okres pierwszy */
  for  select '0' as ID_JB, 0 as WN, sum (ks.KWOTA) as MA ,
   ' ' as KOD_FULL, plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4,  gz.KOD as KOD_Z
  from  FK_KSIEGOWANIA ks
  join FK_S_PLAN_KONT plk on (plk.ID = ks.ID_KONTA_MA)
  join FK_DOKUMENTY dok  on (ks.ID_DOKUMENTY = dok.ID )
  join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY= 'T')
      and (d.data_dok between :DATAOD1 and :DATADO1)
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
  left join PB_ZADANIA z on (z.ID_ZADANIA = plk.ID_ZADANIA)
  left join PB_S_GrupyZ gz on (gz.ID_GRZ = z.grupa_wzp)
  where dok.ID_JB in ( select ID_JB from GET_JB_FROM_LIST (:JEDNOSTKI) )
  and (dok.data_dok between  :DATAOD1 and :DATADO1 )
  group by
  plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4, gz.KOD
  into :ID_JB, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z
  do
  begin
    insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, ZAANGAZOWANIE, REALIZACJA,
     NAZWA, DZIAL, ROZDZIAL, PAR, PAR4, KOD)
    values
    (:ID, :ID_JB, 1, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :KOD_Z) ;
  end


  /* Okres drugi */
  for  select '0' as ID_JB, 0 as WN, -sum (ks.KWOTA) as MA ,
   ' ' as KOD_FULL, plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4,  gz.KOD as KOD_Z
  from  FK_KSIEGOWANIA ks
  join FK_S_PLAN_KONT plk on (plk.ID = ks.ID_KONTA_MA)
  join FK_DOKUMENTY dok  on (ks.ID_DOKUMENTY = dok.ID )
  join (
      select d.ID_PIERWOTNY as IDP, max(d.WERSJA) WER
      from FK_DOKUMENTY d
      join FK_S_STATUSY s on d.STATUS = s.ID
      where s.CZY_USUNIETY = 'N'
      and (s.CZY_ZATWIERDZONY= 'T')
      and (d.data_dok between :DATAOD2 and :DATADO2)
      group by d.ID_PIERWOTNY) on (IDP=dok.ID_PIERWOTNY and WER=dok.WERSJA)
  left join PB_ZADANIA z on (z.ID_ZADANIA = plk.ID_ZADANIA)
  left join PB_S_GrupyZ gz on (gz.ID_GRZ = z.grupa_wzp)
  where dok.ID_JB in ( select ID_JB from GET_JB_FROM_LIST (:JEDNOSTKI) )
  and (dok.data_dok between  :DATAOD2 and :DATADO2 )
  group by
  plk.DZIAL , plk.ROZDZIAL, plk.PAR , plk.PAR4,  gz.KOD
  into :ID_JB, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z
  do
  begin
   insert into FK_RAPORT(ID, ID_DOKUMENTU, POZIOM, ZAANGAZOWANIE, REALIZACJA,
     NAZWA, DZIAL, ROZDZIAL, PAR, PAR4, KOD)
    values
    (:ID, :ID_JB, 2, :WN, :MA, :KOD_FULL, :DZIAL, :ROZDZIAL,  :PAR, :PAR4, :KOD_Z) ;
  end

   /* Sumowanie okresw */
   for select rp.ID_DOKUMENTU, sum (rp.ZAANGAZOWANIE), sum (rp.REALIZACJA), rp.DZIAL, rp.ROZDZIAL,
   rp.PAR, rp.PAR4, rp.KOD, rp.NAZWA
   from  FK_RAPORT rp where rp.ID =:ID
   group by  rp.ID_DOKUMENTU, rp.DZIAL, rp.ROZDZIAL, rp.PAR, rp.PAR4, rp.KOD, rp.NAZWA
   into :ID_JB, :WN, :MA, :DZIAL, :ROZDZIAL, :PAR, :PAR4, :KOD_Z, :KOD_FULL
   do
   begin
       if (:WN<>0 or :MA<>0) then suspend;
   end

    /*Usuwanie rekordw*/

   execute procedure CLEAN_RAPORT :ID;


end^

SET TERM ; ^

GRANT SELECT ON FK_KSIEGOWANIA TO PROCEDURE GET_ZAANG_EKSPORT_RODZ_ZAD;

GRANT SELECT ON FK_S_PLAN_KONT TO PROCEDURE GET_ZAANG_EKSPORT_RODZ_ZAD;

GRANT SELECT ON FK_DOKUMENTY TO PROCEDURE GET_ZAANG_EKSPORT_RODZ_ZAD;

GRANT SELECT ON FK_S_STATUSY TO PROCEDURE GET_ZAANG_EKSPORT_RODZ_ZAD;

GRANT SELECT ON PB_ZADANIA TO PROCEDURE GET_ZAANG_EKSPORT_RODZ_ZAD;

GRANT SELECT ON PB_S_GRUPYZ TO PROCEDURE GET_ZAANG_EKSPORT_RODZ_ZAD;

GRANT EXECUTE ON PROCEDURE GET_JB_FROM_LIST TO PROCEDURE GET_ZAANG_EKSPORT_RODZ_ZAD;

GRANT SELECT,INSERT ON FK_RAPORT TO PROCEDURE GET_ZAANG_EKSPORT_RODZ_ZAD;

GRANT EXECUTE ON PROCEDURE CLEAN_RAPORT TO PROCEDURE GET_ZAANG_EKSPORT_RODZ_ZAD;

GRANT EXECUTE ON PROCEDURE GET_ZAANG_EKSPORT_RODZ_ZAD TO SYSDBA;

/*--------------------------------------------------------------- */




